package org.bitbucket.bradleysmithllc.etlunit.util;

import com.fasterxml.jackson.databind.JsonNode;
import com.github.fge.jackson.JsonLoader;
import com.github.fge.jsonschema.exceptions.ProcessingException;
import com.github.fge.jsonschema.main.JsonSchema;
import com.github.fge.jsonschema.main.JsonSchemaFactory;
import com.github.fge.jsonschema.report.ProcessingReport;

public class JsonSchemaValidator
{
	public static void validateV4Schema(JsonNode node)
	{
		JsonSchemaFactory fact = JsonSchemaFactory.byDefault();

		try {
			JsonNode draftNode = JsonLoader.fromURL(JsonSchemaValidator.class.getResource("/draftv4/schema"));

			JsonSchema schema = fact.getJsonSchema(draftNode);

			ProcessingReport report = schema.validate(node);

			if (!report.isSuccess())
			{
				throw new IllegalArgumentException(JsonProcessingUtil.getProcessingReport(report));
			}
		} catch (ProcessingException e) {
			throw new RuntimeException(JsonProcessingUtil.getProcessingReport(e));
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}
}