package org.bitbucket.bradleysmithllc.etlunit.util;

public class TestCase
{
	private final String testName;
	private final long time;
	private boolean failure;
	private boolean error;

	private final StringBuilder stdout = new StringBuilder();

	public TestCase(String tn, long t)
	{
		testName = tn;
		time = t;
	}

	public String getTestName()
	{
		return testName;
	}

	public void setError()
	{
		error = true;
	}

	public void setFailure()
	{
		failure = true;
	}

	public boolean isFailure()
	{
		return failure;
	}

	public boolean isError()
	{
		return error;
	}

	public long getTimeInMillis()
	{
		return time;
	}

	public double getTime()
	{
		return (time / 1000.0D);
	}

	public StringBuilder getStdout()
	{
		return stdout;
	}

	public String getStdoutString()
	{
		return stdout.toString();
	}
}